diff --git a/drupal7/sites/all/modules/media/media.module b/drupal7/sites/all/modules/media/media.module
index da42a875..3c54914a 100644
--- a/drupal7/sites/all/modules/media/media.module
+++ b/drupal7/sites/all/modules/media/media.module
@@ -8,20 +8,9 @@
  * See http://drupal.org/project/media for more details.
  */
 
-/* ***************************************** */
-/* INCLUDES                                  */
-/* ***************************************** */
-
 // Code relating to using media as a field.
 require_once dirname(__FILE__) . '/includes/media.fields.inc';
 
- // Functions for working with [[inline tags]] and wysiwyg editors.
-require_once dirname(__FILE__) . '/includes/media.filter.inc';
-
-/* ***************************************** */
-/* Hook Implementations                      */
-/* ***************************************** */
-
 /**
  * Implements hook_hook_info().
  */
@@ -32,9 +21,6 @@ function media_hook_info() {
     'media_browser_plugin_info_alter',
     'media_browser_plugins_alter',
     'media_browser_params_alter',
-    'media_wysiwyg_allowed_view_modes_alter',
-    'media_format_form_prepare_alter',
-    'media_token_to_markup_alter',
     'query_media_browser_alter',
   );
 
@@ -71,35 +57,22 @@ function media_entity_info_alter(&$entity_info) {
   // For sites that updated from Media 1.x, continue to provide these deprecated
   // view modes.
   // @see http://drupal.org/node/1051090
-  if (variable_get('media__show_deprecated_view_modes', FALSE)) {
-    $entity_info['file']['view modes'] += array(
-      'media_link' => array(
-        'label' => t('Link'),
-        'custom settings' => TRUE,
-      ),
-      'media_original' => array(
-        'label' => t('Original'),
-        'custom settings' => TRUE,
-      ),
+  if (variable_get('media_show_deprecated_view_modes', FALSE)) {
+    $entity_info['file']['view modes']['media_link'] = array(
+      'label' => t('Link'),
+      'custom settings' => TRUE,
+    );
+    $entity_info['file']['view modes']['media_original'] = array(
+      'label' => t('Original'),
+      'custom settings' => TRUE,
     );
   }
 
   if (module_exists('entity_translation')) {
     $entity_info['file']['translation']['entity_translation']['class'] = 'MediaEntityTranslationHandler';
-    $entity_info['file']['translation']['entity_translation']['path schemes']['media'] = array('edit path' => 'media/%file/edit/%ctools_js');
   }
 }
 
-/**
- * Access callback for files. This function is deprecated.
- *
- * @todo Completely remove this function in favor of file_entity_access after
- * a few releases, to ensure rest of contib catches up.
- */
-function media_access($op, $account = NULL) {
-  return user_access('administer files', $account);
-}
-
 /**
  * Implements hook_menu().
  */
@@ -127,25 +100,19 @@ function media_menu() {
     'weight' => 10,
   );
 
-  // Used to import files from a local filesystem into Drupal.
-  $items['admin/content/file/import'] = array(
-    'title' => 'Import files',
-    'description' => 'Import files into your media library.',
-    'page callback' => 'drupal_get_form',
-    'page arguments' => array('media_import'),
-    'access arguments' => array('import media'),
-    'type' => MENU_LOCAL_ACTION,
-    'file' => 'includes/media.admin.inc',
-    'weight' => 10,
+  $items['media/ajax'] = array(
+    'page callback' => 'media_ajax_upload',
+    'delivery callback' => 'ajax_deliver',
+    'access arguments' => array('access content'),
+    'theme callback' => 'ajax_base_page_theme',
+    'type' => MENU_CALLBACK,
   );
-  $items['admin/content/file/thumbnails/import'] = $items['admin/content/file/import'];
 
   $items['media/browser'] = array(
     'title' => 'Media browser',
     'description' => 'Media Browser for picking media and uploading new media',
     'page callback' => 'media_browser',
-    'access callback' => 'file_entity_access',
-    'access arguments' => array('create'),
+    'access arguments' => array('access media browser'),
     'type' => MENU_CALLBACK,
     'file' => 'includes/media.browser.inc',
     'theme callback' => 'media_dialog_get_theme_name',
@@ -162,31 +129,6 @@ function media_menu() {
     'file' => 'includes/media.browser.inc',
   );
 
-  $items['media/%file/format-form'] = array(
-    'title' => 'Style selector',
-    'description' => 'Choose a format for a piece of media',
-    'page callback' => 'drupal_get_form',
-    'page arguments' => array('media_format_form', 1),
-    'access callback' => 'file_entity_access',
-    'access arguments' => array('view', 1),
-    'file' => 'includes/media.filter.inc',
-    'theme callback' => 'media_dialog_get_theme_name',
-    'type' => MENU_CALLBACK,
-  );
-
-  if (module_exists('multiform')) {
-    // @todo Investigate passing file IDs in query string rather than a menu
-    // argument and then deprecate media_multi_load().
-    $items['admin/content/file/edit-multiple/%media_multi'] = array(
-      'title' => 'Edit multiple files',
-      'page callback' => 'media_file_page_edit_multiple',
-      'page arguments' => array(4),
-      'access callback' =>  '_media_file_entity_access_recursive',
-      'access arguments' => array(4, 'update'),
-      'file' => 'includes/media.pages.inc',
-    );
-  }
-
   // We could re-use the file/%file/edit path for the modal callback, but
   // it is just easier to use our own namespace here.
   $items['media/%file/edit/%ctools_js'] = array(
@@ -195,24 +137,7 @@ function media_menu() {
     'page arguments' => array('media_file_edit_modal', 1, 3),
     'access callback' => 'file_entity_access',
     'access arguments' => array('update', 1),
-    'file' => 'includes/media.pages.inc',
-    'type' => MENU_CALLBACK,
-  );
-
-  // Upgrade interface for old file types.
-  $items['admin/structure/file-types/upgrade'] = array(
-    'title' => 'Upgrade types',
-    'page callback' => 'drupal_get_form',
-    'page arguments' => array('media_upgrade_file_types'),
-    'access arguments' => array('administer file types'),
-    'file' => 'includes/media.pages.inc',
-    'type' => MENU_CALLBACK,
-  );
-  $items['admin/structure/file-types/upgrade/confirm'] = array(
-    'title' => 'Upgrade types',
-    'page callback' => 'drupal_get_form',
-    'page arguments' => array('media_upgrade_file_types_confirm'),
-    'access arguments' => array('administer file types'),
+    'theme callback' => 'ajax_base_page_theme',
     'file' => 'includes/media.pages.inc',
     'type' => MENU_CALLBACK,
   );
@@ -242,10 +167,11 @@ function media_menu_local_tasks_alter(&$data, $router_item, $root_path) {
  */
 function media_admin_paths() {
   $paths['media/*/edit/*'] = TRUE;
+  $paths['media/*/format-form'] = TRUE;
 
   // If the media browser theme is set to the admin theme, ensure it gets set
   // as an admin path as well.
-  $dialog_theme = variable_get('media__dialog_theme', '');
+  $dialog_theme = variable_get('media_dialog_theme', '');
   if (empty($dialog_theme) || $dialog_theme == variable_get('admin_theme')) {
     $paths['media/browser'] = TRUE;
     $paths['media/browser/*'] = TRUE;
@@ -263,9 +189,8 @@ function media_permission() {
       'title' => t('Administer media browser'),
       'description' => t('Access media browser settings.'),
     ),
-    'import media' => array(
-      'title' => t('Import media files from the local filesystem'),
-      'description' => t('Simple file importer'),
+    'access media browser' => array(
+      'title' => t('Use the media browser'),
     ),
   );
 }
@@ -275,38 +200,101 @@ function media_permission() {
  */
 function media_theme() {
   return array(
-    // The default media file list form element.
-    'media_file_list' => array(
-      'variables' => array('element' => NULL),
+    // media.module.
+    'media_element' => array(
+      'render element' => 'element',
     ),
 
-    // A preview of the uploaded file.
-    'media_thumbnail' => array(
+    // media.field.inc.
+    'media_widget' => array(
       'render element' => 'element',
-      'file' => 'includes/media.theme.inc',
     ),
-
-    // Dialog page.
-    'media_dialog_page' => array(
-      'render element' => 'page',
-      'template' => 'templates/media-dialog-page',
-      'file' => 'includes/media.theme.inc',
+    'media_widget_multiple' => array(
+      'render element' => 'element',
+    ),
+    'media_upload_help' => array(
+      'variables' => array('description' => NULL),
     ),
 
-    // Media form API element type.
-    'media_element' => array(
+    // media.theme.inc.
+    'media_thumbnail' => array(
       'render element' => 'element',
       'file' => 'includes/media.theme.inc',
     ),
-
-    // Display a file as a large icon.
     'media_formatter_large_icon' => array(
       'variables' => array('file' => NULL, 'attributes' => array(), 'style_name' => 'media_thumbnail'),
       'file' => 'includes/media.theme.inc',
     ),
+    'media_dialog_page' => array(
+      'render element' => 'page',
+      'template' => 'templates/media-dialog-page',
+      'file' => 'includes/media.theme.inc',
+    ),
   );
 }
 
+/**
+ * Menu callback; Shared Ajax callback for media attachment and deletions.
+ *
+ * This rebuilds the form element for a particular field item. As long as the
+ * form processing is properly encapsulated in the widget element the form
+ * should rebuild correctly using FAPI without the need for additional callbacks
+ * or processing.
+ */
+function media_ajax_upload() {
+  $form_parents = func_get_args();
+  $form_build_id = (string) array_pop($form_parents);
+
+  if (empty($_POST['form_build_id']) || $form_build_id != $_POST['form_build_id']) {
+    // Invalid request.
+    drupal_set_message(t('An unrecoverable error occurred. The uploaded file likely exceeded the maximum file size (@size) that this server supports.', array('@size' => format_size(file_upload_max_size()))), 'error');
+    $commands = array();
+    $commands[] = ajax_command_replace(NULL, theme('status_messages'));
+    return array('#type' => 'ajax', '#commands' => $commands);
+  }
+
+  list($form, $form_state, $form_id, $form_build_id, $commands) = ajax_get_form();
+
+  if (!$form) {
+    // Invalid form_build_id.
+    drupal_set_message(t('An unrecoverable error occurred. Use of this form has expired. Try reloading the page and submitting again.'), 'error');
+    $commands = array();
+    $commands[] = ajax_command_replace(NULL, theme('status_messages'));
+    return array('#type' => 'ajax', '#commands' => $commands);
+  }
+
+  // Get the current element and count the number of files.
+  $current_element = $form;
+  foreach ($form_parents as $parent) {
+    $current_element = $current_element[$parent];
+  }
+  $current_file_count = isset($current_element['#file_upload_delta']) ? $current_element['#file_upload_delta'] : 0;
+
+  // Process user input. $form and $form_state are modified in the process.
+  drupal_process_form($form['#form_id'], $form, $form_state);
+
+  // Retrieve the element to be rendered.
+  foreach ($form_parents as $parent) {
+    $form = $form[$parent];
+  }
+
+  // Add the special Ajax class if a new file was added.
+  if (isset($form['#file_upload_delta']) && $current_file_count < $form['#file_upload_delta']) {
+    $form[$current_file_count]['#attributes']['class'][] = 'ajax-new-content';
+  }
+  // Otherwise just add the new content class on a placeholder.
+  else {
+    $form['#suffix'] .= '<span class="ajax-new-content"></span>';
+  }
+
+  $output = theme('status_messages') . drupal_render($form);
+  $js = drupal_add_js();
+  $settings = call_user_func_array('array_merge_recursive', $js['settings']['data']);
+
+  $commands[] = ajax_command_replace(NULL, $output, $settings);
+  return array('#type' => 'ajax', '#commands' => $commands);
+}
+
 /**
  * Implements hook_image_default_styles().
  */
@@ -345,110 +333,6 @@ function media_page_alter(&$page) {
       }
     }
   }
-
-  // Check if there are file types that need migration and display a message
-  // to user if so.
-  $menu = menu_get_item();
-  if (variable_get('media__display_types_migration_mess', TRUE) && $menu['path'] == 'admin/structure/file-types') {
-    if ($migratable_types = _media_get_migratable_file_types()) {
-      drupal_set_message(t('There are disabled/deleted file types that can be migrated to their new alternatives. Visit <a href="!url">migration page</a> to get more information.', array('!url' => url('admin/structure/file-types/upgrade'))));
-    }
-  }
-}
-
-/**
- * Implements hook_element_info_alter().
- */
-function media_element_info_alter(&$types) {
-  $types['text_format']['#pre_render'][] = 'media_pre_render_text_format';
-}
-
-/**
- * Implements hook_file_operations().
- */
-function media_file_operations() {
-  $operations = array();
-
-  // If the multiform module is not installed, do not show this option.
-  if (module_exists('multiform')) {
-    $operations['edit_multiple'] = array(
-      'label' => t('Edit selected files'),
-      'callback' => 'media_file_operation_edit_multiple',
-    );
-  }
-
-  return $operations;
-}
-
-/**
- * Return a URL for editing an files.
- *
- * Works with an array of fids or a single fid.
- *
- * @param mixed $fids
- *   An array of file IDs or a single file ID.
- */
-function media_file_edit_url($fids) {
-  if (!is_array($fids)) {
-    $fids = array($fids);
-  }
-
-  if (count($fids) > 1) {
-    return 'admin/content/file/edit-multiple/' . implode(' ', $fids);
-  }
-  else {
-    return 'file/' . reset($fids) . '/edit';
-  }
-}
-
-/**
- * Callback for the edit operation.
- *
- * Redirects the user to the edit multiple files page.
- *
- * @param array $fids
- *   An array of file IDs.
- *
- * @see media_file_page_edit_multiple()
- */
-function media_file_operation_edit_multiple($fids) {
-  // The thumbnail browser returns TRUE/FALSE for each item, so use array keys.
-  $fids = array_keys(array_filter($fids));
-  drupal_goto(media_file_edit_url($fids), array('query' => drupal_get_destination()));
-}
-
-/**
- * Implements hook_forms().
- */
-function media_forms($form_id, $args) {
-  $forms = array();
-  // To support the multiedit form, each form has to have a unique ID.
-  // So we name all the forms media_edit_N where the first requested form is
-  // media_edit_0, 2nd is media_edit_1, etc.
-  module_load_include('inc', 'file_entity', 'file_entity.pages');
-  if ($form_id != 'media_edit' && (strpos($form_id, 'media_edit') === 0)) {
-    $forms[$form_id] = array(
-      'callback' => 'file_entity_edit',
-    );
-  }
-  return $forms;
-}
-
-/**
- * Implements hook_form_FIELD_UI_FIELD_SETTINGS_FORM_alter().
- *
- * @todo: Respect field settings in 7.x-2.x and handle them in the media widget
- * UI.
- */
-function media_form_field_ui_field_settings_form_alter(&$form, &$form_state) {
-  // On file fields that use the media widget we need remove specific fields.
-  if ($form['field']['type']['#value'] == 'file') {
-    $fields = field_info_instances($form['#entity_type'], $form['#bundle']);
-    if ($fields[$form['field']['field_name']['#value']]['widget']['type'] == 'media_generic') {
-      $form['field']['settings']['display_field']['#access'] = FALSE;
-      $form['field']['settings']['display_default']['#access'] = FALSE;
-    }
-  }
 }
 
 /**
@@ -460,9 +344,6 @@ function media_form_field_ui_field_settings_form_alter(&$form, &$form_state) {
 function media_form_field_ui_field_edit_form_alter(&$form, &$form_state) {
   // On file fields that use the media widget we need remove specific fields.
   if ($form['#field']['type'] == 'file' && $form['instance']['widget']['type']['#value'] == 'media_generic') {
-    $form['field']['settings']['display_field']['#access'] = FALSE;
-    $form['field']['settings']['display_default']['#access'] = FALSE;
-    $form['instance']['settings']['description_field']['#access'] = FALSE;
     $form['instance']['settings']['file_extensions']['#title'] = t('Allowed file extensions for uploaded files');
     $form['instance']['settings']['file_extensions']['#maxlength'] = 255;
   }
@@ -475,6 +356,13 @@ function media_form_field_ui_field_edit_form_alter(&$form, &$form_state) {
     // Do not increase maxlength of file extensions for image fields, since
     // presumably they will not need a long list of extensions.
   }
+
+  // Add a validation function to any field instance which uses the media widget
+  // to ensure that the upload destination scheme is one of the allowed schemes.
+  if ($form['instance']['widget']['type']['#value'] == 'media_generic') {
+    $form['#validate'][] = 'media_field_instance_validate';
+  }
+
   if ($form['#instance']['entity_type'] == 'file') {
     $form['instance']['settings']['wysiwyg_override'] = array(
       '#type' => 'checkbox',
@@ -486,19 +374,15 @@ function media_form_field_ui_field_edit_form_alter(&$form, &$form_state) {
 }
 
 /**
- * Implements hook_form_FORM_ID_alter().
+ * Validation handler; ensure that the upload destination scheme is one of the
+ * allowed schemes.
  */
-function media_form_file_entity_edit_alter(&$form, &$form_state) {
-  // Make adjustments to the file edit form when used in a CTools modal.
-  if (!empty($form_state['ajax'])) {
-    // Remove the preview and the delete button.
-    $form['preview']['#access'] = FALSE;
-    $form['actions']['delete']['#access'] = FALSE;
+function media_field_instance_validate($form, &$form_state) {
+  $allowed_schemes = $form_state['values']['instance']['widget']['settings']['allowed_schemes'];
+  $upload_destination = $form_state['values']['field']['settings']['uri_scheme'];
 
-    // Convert the cancel link to a button which triggers a modal close.
-    $form['actions']['cancel']['#attributes']['class'][] = 'button';
-    $form['actions']['cancel']['#attributes']['class'][] = 'button-no';
-    $form['actions']['cancel']['#attributes']['class'][] = 'ctools-close-modal';
+  if (!in_array($upload_destination, array_filter($allowed_schemes))) {
+    form_set_error('allowed_schemes', t('The upload destination must be one of the allowed schemes.'));
   }
 }
 
@@ -534,87 +418,12 @@ function media_browser_form_submit($form, &$form_state) {
     $parameters = array('query' => array('render' => 'media-popup', 'fid' => $file->fid));
   }
 
-  // Multi upload.
-  if (!empty($form_state['files'])) {
-    $files = $form_state['files'];
-    $url = 'media/browser';
-    $parameters = array('query' => array('render' => 'media-popup', 'fid' => array_keys($files)));
-  }
-
   // If $url is set, we had some sort of upload, so redirect the form.
   if (!empty($url)) {
     $form_state['redirect'] = array($url, $parameters);
   }
 }
 
-/**
- * Implements hook_form_FORM_ID_alter().
- */
-function media_form_wysiwyg_profile_form_alter(&$form, &$form_state) {
-  // Add warnings if the media filter is disabled for the WYSIWYG's text format.
-  $form['buttons']['drupal']['media']['#element_validate'][] = 'media_wysiwyg_button_element_validate';
-  $form['buttons']['drupal']['media']['#after_build'][] = 'media_wysiwyg_button_element_validate';
-  form_load_include($form_state, 'inc', 'media', 'wysiwyg_plugins/media');
-}
-
-/**
- * Access callback for the media-multi form.
- *
- * @param $files
- *   An array of files being editing on the multiform.
- * @param $op
- *   A string containing the operation requested, such as 'update'.
- * @return
- *   TRUE if the current user has access to edit all of the files, otherwise FALSE.
- */
-function _media_file_entity_access_recursive($files, $op) {
-  // Check that the current user can access each file.
-  if (!empty($files)) {
-    foreach ($files as $file) {
-      if (!file_entity_access($op, $file)) {
-        return FALSE;
-      }
-    }
-    return TRUE;
-  }
-  return FALSE;
-}
-
-/* ***************************************** */
-/* API FUNCTIONS                             */
-/* ***************************************** */
-
-/**
- * Load callback for %media_multi placeholder in menu paths.
- *
- * @param string $fids
- *   Separated by space (e.g., "3 6 12 99"). This often appears as "+" within
- *   URLs (e.g., "3+6+12+99"), but Drupal automatically decodes paths when
- *   intializing $_GET['q'].
- *
- * @return array
- *   An array of corresponding file entities.
- */
-function media_multi_load($fids) {
-  return file_load_multiple(explode(' ', $fids));
-}
-
-/* ***************************************** */
-/* Callbacks                                 */
-/* ***************************************** */
-
-/**
- * Process callback for the media_browser element.
- */
-function media_file_list_element_process($element, $edit, $form_state, $form) {
-  $element['list'] = array(
-    '#type'     => 'select',
-    '#options'  => $element['#options'],
-    '#size'     => variable_get('media__file_list_size', 10),
-  );
-  return $element;
-}
-
 /**
  * Implements hook_library().
  */
@@ -682,7 +491,7 @@ function media_library() {
  * will default to the administration theme, unless set otherwise.
  */
 function media_dialog_get_theme_name() {
-  return variable_get('media__dialog_theme', variable_get('admin_theme'));
+  return variable_get('media_dialog_theme', variable_get('admin_theme'));
 }
 
 /**
@@ -808,16 +617,16 @@ function media_recursive_check_plain(&$value, $key) {
  * Implements hook_element_info().
  */
 function media_element_info() {
-  $types = array();
   $types['media'] = array(
     '#input' => TRUE,
     '#process' => array('media_element_process'),
-    // '#value_callback' => 'media_element_value',
+    '#value_callback' => 'media_file_value',
     '#element_validate' => array('media_element_validate'),
-    '#theme_wrappers' => array('container'),
-    '#progress_indicator' => 'throbber',
+    '#pre_render' => array('media_element_pre_render'),
+    '#theme' => 'media_element',
+    '#theme_wrappers' => array('form_element'),
+    '#size' => 22,
     '#extended' => FALSE,
-    '#required' => FALSE,
     '#media_options' => array(
       'global' => array(
         // Example: array('image', 'audio');
@@ -826,64 +635,97 @@ function media_element_info() {
         'schemes' => array(),
       ),
     ),
-    '#attributes' => array(
-      'class' => array('media-widget', 'form-item'),
-    ),
     '#attached' => array(
       'library' => array(
         array('media', 'media_browser'),
       ),
     ),
   );
+
+  $setting = array();
+  $setting['media']['global'] = $types['media']['#media_options'];
+
+  $types['media']['#attached']['js'][] = array(
+    'type' => 'setting',
+    'data' => $setting,
+  );
+
   return $types;
 }
 
 /**
  * Process callback for the media form element.
  */
-function media_element_process(&$element, &$form_state, $form) {
-  $fid = isset($element['#value']['fid']) ? $element['#value']['fid'] : 0;
-  $file = $fid ? file_load($fid) : FALSE;
-
-  // Add the CTools modal JavaScript for the edit button if necessary.
+function media_element_process($element, &$form_state, $form) {
   ctools_include('modal');
   ctools_include('ajax');
   ctools_modal_add_js();
+  $fid = isset($element['#value']['fid']) ? $element['#value']['fid'] : 0;
 
   // Set some default element properties.
-  $element['#file'] = $file;
-
-  $element['title'] = array(
-    '#type' => 'item',
-    '#title' => $element['#title'],
-    '#description' => $element['#description'],
-    '#required' => $element['#required'],
-    '#weight' => -100,
+  $element['#file'] = $fid ? file_load($fid) : FALSE;
+  $element['#tree'] = TRUE;
+
+  $ajax_settings = array(
+    'path' => 'media/ajax/' . implode('/', $element['#array_parents']) . '/' . $form['form_build_id']['#value'],
+    'wrapper' => $element['#id'] . '-ajax-wrapper',
+    'effect' => 'fade',
+  );
+
+  // Set up the buttons first since we need to check if they were clicked.
+  $element['attach_button'] = array(
+    '#name' => implode('_', $element['#parents']) . '_attach_button',
+    '#type' => 'submit',
+    '#value' => t('Attach'),
+    '#validate' => array(),
+    '#submit' => array('media_file_submit'),
+    '#limit_validation_errors' => array($element['#parents']),
+    '#ajax' => $ajax_settings,
+    '#attributes' => array('class' => array('attach')),
+    '#weight' => -1,
   );
-  if (isset($element['#title_display'])) {
-    $element['title']['#title_display'] = $element['#title_display'];
-  }
 
-  // @todo This should load from the JS in case of a failed form submission.
   $element['preview'] = array(
-    '#prefix' => '<div class="preview launcher">',
+    'content' => array(),
+    '#prefix' => '<div class="preview">',
     '#suffix' => '</div>',
-    '#weight' => 0,
-    'content' => $file ? media_get_thumbnail_preview($file) : array(),
+    '#ajax' => $ajax_settings,
+    '#weight' => -10,
   );
 
-  // @todo: Perhaps this language logic should be handled by JS since the state
-  // changes on client side after choosing an item.
-  $element['select'] = array(
+  // Substitute the JS preview for a true file thumbnail once the file is
+  // attached.
+  if ($fid && $element['#file']) {
+    $element['preview']['content'] = media_get_thumbnail_preview($element['#file']);
+  }
+
+  // The file ID field itself.
+  $element['upload'] = array(
+    '#name' => 'media[' . implode('_', $element['#parents']) . ']',
+    '#type' => 'textfield',
+    '#title' => t('Enter the ID of an existing file'),
+    '#title_display' => 'invisible',
+    '#field_prefix' => t('File ID'),
+    '#size' => $element['#size'],
+    '#theme_wrappers' => array(),
+    '#attributes' => array('class' => array('upload')),
+    '#weight' => -9,
+  );
+
+  $element['browse_button'] = array(
     '#type' => 'link',
     '#href' => '',
-    '#title' => t('Select'),
-    '#attributes' => array('class' => array('button', 'launcher')),
+    '#title' => t('Browse'),
+    '#attributes' => array('class' => array('button', 'browse', 'element-hidden')),
     '#options' => array('fragment' => FALSE, 'external' => TRUE),
-    '#weight' => 10,
+    '#weight' => -8,
   );
-  // @todo Figure out how to update the preview image after the Edit modal is
-  // closed.
+
+  // Force the progress indicator for the remove button to be either 'none' or
+  // 'throbber', even if the upload button is using something else.
+  $ajax_settings['progress']['type'] = 'throbber';
+  $ajax_settings['progress']['message'] = NULL;
+  $ajax_settings['effect'] = 'none';
   $element['edit'] = array(
     '#type' => 'link',
     '#href' => 'media/' . $fid . '/edit/nojs',
@@ -896,42 +738,128 @@ function media_element_process(&$element, &$form_state, $form) {
       ),
     ),
     '#weight' => 20,
-    '#access' => $file ? file_entity_access('update', $file) : TRUE, // only do perm check for existing files
+    '#access' => $element['#file'] ? file_entity_access('update', $element['#file']) : FALSE,
   );
-  $element['remove'] = array(
-    '#type' => 'link',
-    '#href' => '',
-    '#title' => t('Remove'),
-    '#attributes' => array('class' => array('button', 'remove')),
-    '#options' => array('fragment' => FALSE, 'external' => TRUE),
-    '#weight' => 30,
+  $element['remove_button'] = array(
+    '#name' => implode('_', $element['#parents']) . '_remove_button',
+    '#type' => 'submit',
+    '#value' => t('Remove'),
+    '#validate' => array(),
+    '#submit' => array('media_file_submit'),
+    '#limit_validation_errors' => array($element['#parents']),
+    '#ajax' => $ajax_settings,
+    '#attributes' => array('class' => array('remove')),
+    '#weight' => 0,
   );
 
   $element['fid'] = array(
     '#type' => 'hidden',
     '#value' => $fid,
     '#attributes' => array('class' => array('fid')),
-    '#weight' => 100,
   );
 
   // Media browser attach code.
   $element['#attached']['js'][] = drupal_get_path('module', 'media') . '/js/media.js';
 
-  $setting = array();
-  $setting['media']['elements'][$element['#id']] = $element['#media_options'];
-
-  $element['#attached']['js'][] = array(
-    'type' => 'setting',
-    'data' => $setting,
+  // Add the media options to the page as JavaScript settings.
+  $element['browse_button']['#attached']['js'] = array(
+    array(
+      'type' => 'setting',
+      'data' => array('media' => array('elements' => array('#' . $element['#id'] => $element['#media_options'])))
+    )
   );
 
-  // @todo: Might need to think about this. All settings would likely apply to
-  // all media in a multi-value, but what about passing the existing fid?
   module_load_include('inc', 'media', 'includes/media.browser');
   media_attach_browser_js($element);
 
+  // Prefix and suffix used for Ajax replacement.
+  $element['#prefix'] = '<div id="' . $element['#id'] . '-ajax-wrapper">';
+  $element['#suffix'] = '</div>';
+
   return $element;
-  // @todo: make this work for file and image fields.
+}
+
+/**
+ * Implements hook_form_FORM_ID_alter().
+ */
+function media_form_file_entity_edit_alter(&$form, &$form_state) {
+  // Make adjustments to the file edit form when used in a CTools modal.
+  if (!empty($form_state['ajax'])) {
+    // Remove the preview and the delete button.
+    $form['preview']['#access'] = FALSE;
+    $form['actions']['delete']['#access'] = FALSE;
+
+    // Convert the cancel link to a button which triggers a modal close.
+    $form['actions']['cancel']['#attributes']['class'][] = 'button';
+    $form['actions']['cancel']['#attributes']['class'][] = 'button-no';
+    $form['actions']['cancel']['#attributes']['class'][] = 'ctools-close-modal';
+  }
+}
+
+/**
+ * The #value_callback for a media type element.
+ */
+function media_file_value(&$element, $input = FALSE, $form_state = NULL) {
+  $fid = 0;
+
+  // Find the current value of this field from the form state.
+  $form_state_fid = $form_state['values'];
+  foreach ($element['#parents'] as $parent) {
+    $form_state_fid = isset($form_state_fid[$parent]) ? $form_state_fid[$parent] : 0;
+  }
+
+  if ($element['#extended'] && isset($form_state_fid['fid'])) {
+    $fid = $form_state_fid['fid'];
+  }
+  elseif (is_numeric($form_state_fid)) {
+    $fid = $form_state_fid;
+  }
+
+  // Process any input and attach files.
+  if ($input !== FALSE) {
+    $return = $input;
+
+    // Attachments take priority over all other values.
+    if ($file = media_attach_file($element)) {
+      $fid = $file->fid;
+    }
+    else {
+      // Check for #filefield_value_callback values.
+      // Because FAPI does not allow multiple #value_callback values like it
+      // does for #element_validate and #process, this fills the missing
+      // functionality to allow File fields to be extended through FAPI.
+      if (isset($element['#file_value_callbacks'])) {
+        foreach ($element['#file_value_callbacks'] as $callback) {
+          $callback($element, $input, $form_state);
+        }
+      }
+      // Load file if the FID has changed to confirm it exists.
+      if (isset($input['fid']) && $file = file_load($input['fid'])) {
+        $fid = $file->fid;
+      }
+    }
+  }
+
+  // If there is no input, set the default value.
+  else {
+    if ($element['#extended']) {
+      $default_fid = isset($element['#default_value']['fid']) ? $element['#default_value']['fid'] : 0;
+      $return = isset($element['#default_value']) ? $element['#default_value'] : array('fid' => 0);
+    }
+    else {
+      $default_fid = isset($element['#default_value']) ? $element['#default_value'] : 0;
+      $return = array('fid' => 0);
+    }
+
+    // Confirm that the file exists when used as a default value.
+    if ($default_fid && $file = file_load($default_fid)) {
+      $fid = $file->fid;
+    }
+  }
+
+  $return['fid'] = $fid;
+
+  return $return;
 }
 
 /**
